use FileHandle;
use Socket;

$filename="/home/flow-tools/etc/ip_domain_flow.csv";
my %transchool = maketrantable($filename,"school","net");

# main function getschoolbyip
sub getschoolbyip {
	my ($cip) = @_;
if ( $cip eq "" ) {
	$return="";
} else {
	$mask = "255.255.255.0";
	($ipa,$ipb,$ipc,$ipd) = split(m"\.", $cip);
	$cip3 = $ipa.".".$ipb.".".$ipc;

	if ( $cip3 eq "163.15.147") {
        	$mask="255.255.255.224";
	} elsif ($cip3 eq "192.192.17") {
	        $mask="255.255.255.240";
	} elsif ($cip3 eq "203.71.119") {
	        $mask="255.255.255.240";
	}

	if ( $mask eq "255.255.255.0" ) {
		$net = $cip3.".0";
	} else {
		$icip = inet_aton($cip);
		$imask = inet_aton($mask);
		$inet = $icip & $imask;
		$net = inet_ntoa($inet);
	}

	if ( $transchool{$net} eq "" ) {
		$return = "********";
	} else {
		$return = $transchool{$net};
	}
}
	return($return);
}

# sub Function
# qɮ׫إnetintഫ
sub maketrantable {
        my ($filename,$getname,$byname) = @_;
        my $fh = new FileHandle("$filename") || die;
        my ($line, $returen) = ('', []);

        chomp($line = <$fh>);
	@keyelement = split(m"\,", $line); 
	for ($xx=0 ; $xx < @keyelement ; $xx++) {
		if ( $keyelement[$xx] eq $getname ) { $getkey = $xx; }
		if ( $keyelement[$xx] eq $byname ) { $bykey = $xx; }
	}
        chomp(@lines = <$fh>);
        foreach $line (@lines) {
                my ($element, @elements) = ('', ( ));
                @elements = split(m"\,", $line);
#                $return{$elements[2]}=$elements[4];
		$return{$elements[$bykey]}=$elements[$getkey];
        }
        return(%return);
}
